c  io_write_fmft.f
c  Write FMFT frequencies (for all TPs) to `fmft.out' file.
c  Miroslav Broz (miroslav.broz@email.cz), Mar 18th 2003

      subroutine io_write_fmft(t,nbod,ntp,istat,g,s,iu,fopenstat)

      include 'swift.inc'

      integer iu,nbod,ntp
      integer istat(1,-NPLMAX:NTPMAX)
      real*8 t
      real*8 g(1:NTPMAX),s(1:NTPMAX)
      character*(*) fopenstat

      integer i,ierr

      integer i1st
      save i1st
      data i1st /0/

c=======================================================================
c  ... executable code

      if (i1st.eq.0) then
        call io_open(iu,'fmft.out',fopenstat,'FORMATTED',ierr)
        if (ierr.ne.0) then
          write(*,*) ' SWIFT ERROR: in io_write_fmft: '
          write(*,*) '     Could not open fmft.out:'
          call util_exit(1)
        endif
        i1st = 1
      else
        call io_open(iu,'fmft.out','append','FORMATTED',ierr)
      endif

      do i = 1, ntp
        if (istat(i,1).eq.0) then
          write(iu,10) i, t, g(i), s(i)
10        format(1x,i5,2x,1e23.16,2(2x,1g18.10))
        endif
      enddo
 
      close(iu)
 
      return
      end

