c  Off-line version of the proper elements filter.
c  Miroslav Broz (miroslav.broz@email.cz), Mar 11th 2003

      include 'swift.inc'
      include 'filter.inc'
      include 'flt_cb.inc'
      include 'proper.inc'
      include 'oscel_cb.inc'
      include 'meanel_cb.inc'

      integer iflgchk, nbod, nleft, ntp
      integer istat(NTPMAX,NSTAT)

c  temporary vars
      integer i, j, i1st, iuf, iup, ierr, istep, id
      real*8 dtproper, capa, e, inc, peri, node, varpi, sininc2, t, t1
      character*80 infilterfile, inproperfile, outproperfile, fopenstat,
     :  outfile
      real*8 elmts(-NPLMAX:NTPMAX,6)

c------------------------------------------------------------------------
c
c  read input parameters
c
      write(*,*) 'Enter name of binary input file (mean or osc. el.): '
      read(*,10) infilterfile
10    format(a)
      write(*,*) 'Enter name of binary output file: '
      read(*,10) outfile
      write(*,*) 'Enter name of proper parameters file : '
      read(*,10) inproperfile

      call io_init_proper(inproperfile,dtproper,outproperfile,
     :  iflgchk)
c
c  read input file sequentially and call io_write_proper subroutine
c
      iuf = 20 
      iup = 30 
      fopenstat = 'unknown'
      open(unit=iuf, file=infilterfile,status='old',form='unformatted',
     :  iostat=ierr)
      if (ierr.ne.0) then
         write(*,20) infilterfile
20       format('Error opening ',a)
         stop
      endif

      ntp = 0
      i1st = 0
      FNdtout = -1
      dtfilter = 0.d0
100   continue

c  read a record
        call read_data(iuf,t,nbod,nleft,elmts,istep,
     :    ntp,istat)
        if (istep.eq.0) goto 999

c  prepare input for io_write_proper
c  the 4th filter requires osculating elements for both PLs and TPs
        if (prop_ftype.eq.4) then
          t0 = t
          upflg_osc = .true.

          do i = 2, nbod
            id = -i
            do j = 1, 6
              osc_elmts(j, id) = elmts(j, id)
            enddo
          enddo

          do i = 1, ntp
            if (istat(i,1).eq.0) then
              do j = 1, 6
                osc_elmts(j, i) = elmts(i, j)
              enddo
            endif
          enddo

c  other filters need mean elements of TPs only (in 7 fields)
        else
          upflg_mean = .true.
          do i = 1, ntp
            if (istat(i,1).eq.0) then
              mean_elmts(1, i) = elmts(i, 1)
              e = elmts(i, 2)
              inc = elmts(i, 3)
              node = elmts(i, 4)
              peri = elmts(i, 5)
              varpi = peri + node
              mean_elmts(2, i) = e * cos(varpi)
              mean_elmts(3, i) = e * sin(varpi)
              sininc2 = sin(0.5d0*inc)
              mean_elmts(4, i) = sininc2 * cos(node)
              mean_elmts(5, i) = sininc2 * sin(node)
              mean_elmts(6, i) = e
              mean_elmts(7, i) = inc
            endif
          enddo
        endif

c  store (write) proper elements
        call io_write_proper(t,nbod,ntp,istat,outfile,iup,
     :    fopenstat)

      goto 100

999   continue
      close(iuf)
      close(iup)

      end

c-----------------------------------------------------------------------
c
c  Read one record from the binary input file into array elmts.
c
      subroutine read_data(iuf,t,nbod,nleft,elmts,istep,
     :  ntp,istat)

      include 'swift.inc'
c  input
      integer iuf	! binary file handle
c  output
      real*8 t		! time read from binary file (to be displayed)
      integer nbod	! number of massive bodies
      integer nleft	! number of test particles
      real*8 elmts(-NPLMAX:NTPMAX,6)	! array of orbital elements
      integer istep	! if flag.eq.0 we are at the end of binary file
      integer ntp,istat(NTPMAX)
c-----------------------------------------------------------------------
      real*8 a,e,inc,capom,omega,capm
      integer ierr,i,id
c  functions
      integer io_read_hdr_r,io_read_line_r

10    continue
      istep = 0
      ierr = io_read_hdr_r(iuf,t,nbod,nleft)
c  leave it in days!
c      t = t /365.25d6
      if (ierr.ne.0) goto 999
      if (ntp.eq.0) ntp = nleft

      do i=2,nbod
        ierr = io_read_line_r(iuf,id,a,e,inc,capom,omega,capm)
        if (ierr.ne.0) goto 999
        istep = 1
        id=-1*i
        elmts(id,1)=a
        elmts(id,2)=e
        elmts(id,3)=inc
        elmts(id,4)=capom
        elmts(id,5)=omega
        elmts(id,6)=capm
      enddo

      do i=1, NTPMAX
        istat(i) = 1
      enddo
      do i=1,nleft
        ierr = io_read_line_r(iuf,id,a,e,inc,capom,omega,capm)
c        write(*,*) 'ierr=',ierr
        if (ierr.ne.0) goto 999
        istep = 1
        elmts(id,1)=a
        elmts(id,2)=e
        elmts(id,3)=inc
        elmts(id,4)=capom
        elmts(id,5)=omega
        elmts(id,6)=capm
        istat(id) = 0
c        write(*,*) 'id=',id

c  a check due to initially discarded TPs!
        ntp=max(ntp, id)
      enddo

999   continue

c      write(*,*) 't=',t,'ntp=',nleft,'istat=',(istat(i),i=1,nleft)
      return
      end
c-----------------------------------------------------------------------

